{$U100}

PROGRAM Load_gemfont_demo_pas;

{**************************************************************************
 *                                                                        *
 *                         TACKLE BOX ST DEMO                             *
 *                                                                        *
 * This Demo is included as part of the TACKLE BOX ST utility for         *
 * Personal Pascal.  You may freely use or change this demo in any way    *
 * you see fit.  If you make extensive changes to this demo, we would     *
 * appreciate you sending us a copy so that we may distribute it to other *
 * Personal Pascal users.  Thank you.                                     *
 *                                                                        *
 *                             Rusty Mullins                              *
 *                             compuserve: 70707,3045                     *
 *                             genie: R.E.MULLINS                         *                                              *
 *                                                                        *
 *                                SRM ENTERPRISES                         *
 *                                P.O. BOX 40                             *
 *                                USAFA, CO 80840                         *
 *                                (719) 472-6624                          *
 *                                                                        *
 *                                                                        *
 *                                                                        *
 *     FNTDEMO.PAS (version 1.00) is a demo to load GDOS compatible fonts *
 *     and NON-GDOS compatible fonts WITHOUT using GDOS.                  *
 *                                                                        *
 *     The documentation that goes along with this demo is contained in   *
 *     Tutorial chapter and is called 'Using fonts without GDOS.'  This   *
 *     tutorial hopefully explains everything you need to know about      *
 *     loading, using and unloading fonts.                                *
 *                                                                        *
 *                                                                        *
 *    Compiling this Program:                                             *
 *                                                                        *
 *    There is nothing special about compiling this program.  All VDI     *
 *    and AES commands are there (nothing to INCLUDE).  Just compile and  *
 *    link for GEM (make sure you link with 'LOADFNT.O'.                  *
 *                                                                        *
 *                                                                        *
 *    Running this Program:                                               *
 *                                                                        *
 *    1.  Double click on FNTDEMO.PRG                                     *
 *                                                                        *
 *        NOTE: FNTDEMO.PRG looks to Drive A for the necessary fonts.     *
 *              This does not mean FNTDEMO.PRG will only work off of      *
 *              Drive A.  If you wish to use any other drive, just        *
 *              change the drive path in the file selector box.           *
 *                                                                        *
 **************************************************************************}


CONST

{$I gemconst.pas}

TYPE
    search = packed record                               {file DTA}
               rsrvd:packed array [0..19] of byte;
               rsrvd2: byte;
               attrib: byte;
               time:integer;
               date:integer;
               size:long_integer;
               name:packed array [1..14] of char;
             end;

{$I gemtype.pas}

VAR
   font_title:Window_title;                           {GEM window stuff}
   menu:menu_ptr;                                     {GEM menu pointer}

   prog_title,                                        {menu items}
   line_item,                                         {menu items}
   quit_item,                                         {menu items}

   which,                                             {Event parameters}
   dummy,                                             {Event parameters}

   font_window,                                       {window handle}
   x,y,w,h,                                           {size parameters}

   vdi_handle,                                        {vdi handle}
   rez,                                               {screen resolution}

   error_code,                                        {error code var}
   element_num                                        {number of fonts}
   :integer;                                          {declare as integer}


    font_name: array [1..100] of string;              {font name}
    name_of_file: array [1..100] of string;           {file name}
    font_size: array [1..100] of long_integer;        {font size}
    font_id: array [1..100] of integer;               {font ID}
    font_adr: array [1..100] of long_integer;         {font address}

    error_num,                                        {error return var} 
    linea_parm,                                       {Line A address}
    effects_buf,                                      {effects buffer addr}
    color_parm,                                       {color address}
    mono_parm                                         {monochrome address}
    :long_integer;                                    {as long integer}
  
    fonts_loaded:boolean;                             {redraw font dlag}

    file_dta:search;                                  {file dta buffer}

{$I auxsubs.pas}
{$I gemsubs.pas}


{*************************************************************************
 *                                                                       *
 *          EXTERNAL DECLARATIONS:  These can also be found in the       *
 *          file called 'FONTSUBS.PAS'.  For the sake of clarity, I      *
 *          have listed these externals instead of including them.       *
 *                                                                       *
 *************************************************************************}

FUNCTION get_fontid(vdi_hand,ele_num:integer; 
                    VAR face_name:string):integer; EXTERNAL;

FUNCTION set_font(vdi_hand,id_font:integer):integer; EXTERNAL;

PROCEDURE text_rotation(vdi_hand,angle:integer); EXTERNAL;

PROCEDURE text_alignment(vdi_hand,hor_align,ver_align:integer;
                         VAR set_hor,set_ver:integer); EXTERNAL;

PROCEDURE text_justify(vdi_hand,x,y:integer; VAR text_str:string;
                       len_str,word_str,char_str:integer); EXTERNAL;

FUNCTION Init_fonts(VAR sys_font,eff_buf,color,
                    mono:long_integer):long_integer; EXTERNAL;

PROCEDURE Restore_System(line_a_parm,color_value,
                         mono_value:long_integer); EXTERNAL;

FUNCTION Free_memory(font_addr:long_integer):long_integer; EXTERNAL;

PROCEDURE Link_fonts(first_addr,second_addr:long_integer); EXTERNAL;

FUNCTION Reg_fonts(vdi_hand:integer; font_addr,
                   eff_buf:long_integer):integer; EXTERNAL;

FUNCTION Load_font(vdi_hand:integer; VAR name:string; 
                   size:long_integer):long_integer; EXTERNAL;


{*************************************************************************
 *                                                                       *
 *          EXTERNAL DECLARATIONS:  Other externals needed for this      *
 *          demo.                                                        *
 *                                                                       *
 *************************************************************************}

FUNCTION getrez:integer; XBIOS(4);
 
FUNCTION get_port:integer; EXTERNAL;

PROCEDURE fsetdta(VAR buf:search); GEMDOS($1A);

FUNCTION fsfirst(VAR path:c_string; search_attrib:integer):integer;
    GEMDOS($4E);


{*****************************************************************************
 *                                                                           *
 *                      ADVERTISMENT!                                        *
 *                                                                           *
 *****************************************************************************}

PROCEDURE about_ldgfont;
    VAR dialog:dialog_ptr;
        prompt,prompt1,prompt2,prompt3,prompt4,prompt5,prompt6,prompt7,
        prompt8,prompt9,which_btn:integer;

    BEGIN
       dialog:=new_dialog(20,0,0,35,14);
       prompt:=add_ditem(dialog,g_string,none,2,1,0,0,0,0);
       set_dtext(dialog,prompt,'LOAD GDOS FONTS   version 1.00',
                 system_font,te_center);

       prompt1:=add_ditem(dialog,g_string,none,2,2,0,0,0,0);
       set_dtext(dialog,prompt1,'Written by:      Rusty Mullins',
                 system_font,te_center);

       prompt2:=add_ditem(dialog,g_string,none,2,3,0,0,0,0);
       set_dtext(dialog,prompt2,'Portions  of  this  demo  are',
                 system_font,te_center);

       prompt3:=add_ditem(dialog,g_string,none,2,4,0,0,0,0);
       set_dtext(dialog,prompt3,'Copyright (c) 1986, CCD & OSS.',
                 system_font,te_center);

       prompt4:=add_ditem(dialog,g_string,none,2,5,0,0,0,0);
       set_dtext(dialog,prompt4,'Used  by  permission  of  OSS.',
                 system_font,te_center);

       prompt5:=add_ditem(dialog,g_string,none,2,6,0,0,0,0);
       set_dtext(dialog,prompt5,'FNTDEMO was written as a demo',
                 system_font,te_center);

       prompt6:=add_ditem(dialog,g_string,none,2,7,0,0,0,0);
       set_dtext(dialog,prompt6,'for TACKLE BOX ST,  a utility',
                 system_font,te_center);

       prompt7:=add_ditem(dialog,g_string,none,2,8,0,0,0,0);
       set_dtext(dialog,prompt7,'for  Personal  Pascal.   Want',
                 system_font,te_center);

       prompt8:=add_ditem(dialog,g_string,none,2,9,0,0,0,0);
       set_dtext(dialog,prompt8,'more info?  Call: 719-472-6624',
                 system_font,te_center);

       prompt9:=add_ditem(dialog,g_button,selectable|exit_btn|default,
                          14,11,6,2,2,$1180);
       set_dtext(dialog,prompt9,' OK ',system_font,te_center);

       center_dialog(dialog);
       which_btn:=do_dialog(dialog,0);
       end_dialog(dialog);
    END;


{**************************************************************************
 *                                                                        *
 *             Could not open a window.                                   *
 *                                                                        *
 *             INPUT: None.                                               *
 *                                                                        *
 *             OUTPUT: None                                               *
 *                                                                        *
 *             CALLED BY: Wind_font                                       *
 *                                                                        *
 *****************************************************************************}

PROCEDURE error_window;                              {no windows available}
    VAR alert1,alert2:string[80];
        alert3:string[255];
        dummy:integer;
    BEGIN
       alert1:='[1][GEM could not open a window.|Try closing another window|';
       alert2:='you no longer need and try again.|][ OK ]';
       alert3:=concat(alert1,alert2);
       dummy:=do_alert(alert3,1);
    END;


{**************************************************************************
 *                                                                        *
 *             OPEN A WINDOW                                              *
 *                                                                        *
 *             INPUT: None                                                *
 *                                                                        *
 *             OUTPUT: None                                               *
 *                                                                        *
 *             CALLED BY: Event Manager.                                  *
 *                                                                        *
 **************************************************************************}

PROCEDURE wind_font;
    VAR I:integer;
    BEGIN
       IF font_window=0 THEN
          BEGIN
             font_title:=CONCAT(' LOAD GDOS FONT DEMO ');
             font_window:=New_Window(G_All,font_title,0,0,0,0);
             IF font_Window<0 THEN error_window
             ELSE
                BEGIN
                   Open_Window(font_window,0,0,0,0);
                   work_rect(font_window,x,y,w,h);
                   Set_clip(x,y,w,h);
                END
          END
       ELSE Bring_To_Front(font_window);
    END;


{*************************************************************************
 *                                                                       *
 *             Draw Fonts: Used by the redraw message to draw the        *
 *                         screen before and after the fonts are loaded  *                    
 *                                                                       *
 *             INPUT: None                                               *
 *                                                                       *
 *             OUTPUT: None                                              *
 *                                                                       *
 *             CALLED BY: Event Manager.                                 *
 *                                                                       *
 *************************************************************************}

PROCEDURE draw_fonts;
    VAR I,font_set,hor,ver:integer;
    BEGIN
       hide_mouse;
       text_Color (black);
       work_rect(font_window,x,y,w,h);
       set_clip(x,y,w,h);
       paint_color(white);                  {clear the window}
       paint_style(solid);
       paint_rect(x,y,w,h);

       IF fonts_loaded = TRUE THEN
         BEGIN
            FOR I:=1 TO element_num DO
              BEGIN
                 font_set:=set_font(vdi_handle,font_id[I]);
                 draw_string(x+20,y+(I*15)*rez,font_name[I]);
              END;
         
         END;    
       show_mouse;
    END;


{*************************************************************************
 *                                                                       *
 *             Check Font: Check to see if Load_font returned an         *
 *                         error code.  If no error occurred, I          *                    
 *                         increment my font counter (element_num)       *
 *                         and set a flag (fonts_loaded) to TRUE.        *
 *                                                                       *
 *             INPUT: None                                               *
 *                                                                       *
 *             OUTPUT: None                                              *
 *                                                                       *
 *             CALLED BY: Select_fonts().                                *
 *                                                                       *
 *************************************************************************}

PROCEDURE check_font;
    BEGIN
       IF font_adr[element_num]>0 THEN 
         BEGIN      
            element_num:=element_num+1;
            fonts_loaded:=TRUE;
         END
       ELSE IF font_adr[element_num]=-33 THEN 
            draw_string(x+20,y+25*rez,'FONT NOT FOUND')
       ELSE IF font_adr[element_num]=-39 THEN 
            draw_string(x+20,y+25*rez,'NOT ENOUGH MEMORY');
    END;


{*************************************************************************
 *                                                                       *
 *             Select Fonts.                                             *
 *                                                                       *
 *              1. Loads the fonts.                                      *                    
 *              2. Links the fonts together.                             *
 *              3. Registers the fonts with VDI.                         *
 *              4. Gets the font name and ID.                            *
 *              5. Calls 'Draw_fonts' to update screen.                  *
 *                                                                       *
 *             INPUT: None                                               *
 *                                                                       *
 *             OUTPUT: None                                              *
 *                                                                       *
 *             CALLED BY: Event Manager.                                 *
 *                                                                       *
 *************************************************************************}

PROCEDURE select_fonts;
    VAR I,fonts_reg:integer;
        def_path,get_file:path_name;
        c_search:c_string;

    BEGIN
      def_path:='A:*.*';
      get_file:='';
      element_num:=2;
      WHILE (get_in_file(def_path,get_file) = TRUE) DO
        BEGIN
           name_of_file[element_num]:=get_file;
           p_to_cstr(name_of_file[element_num],c_search);
           fsetdta(file_dta);
           IF fsfirst(c_search,23)=0 THEN 
             BEGIN
                font_size[element_num]:=file_dta.size;

                font_adr[element_num]:=Load_font(vdi_handle,
                                                 name_of_file[element_num],
                                                 font_size[element_num]);
                check_font;
             END;
        END;

       element_num:=element_num-1;

       FOR I:=1 TO element_num-1 DO 
         link_fonts(font_adr[I],font_adr[I+1]);

       fonts_reg:=reg_fonts(vdi_handle,font_adr[1],effects_buf);

       FOR I:=1 TO element_num DO 
         font_id[I]:=get_fontid(vdi_handle,I,font_name[I]);

       draw_fonts;
    END;


{*************************************************************************
 *                                                                       *
 *             Restore memory.  Frees up memory used by the fonts.       *
 *                                                                       *
 *             INPUT: None                                               *
 *                                                                       *
 *             OUTPUT: None                                              *
 *                                                                       *
 *             CALLED BY: Main Program.                                  *
 *                                                                       *
 *************************************************************************}

PROCEDURE restore_memory;
    VAR I:integer;
        error:long_integer;
    BEGIN
       FOR I:=2 TO element_num DO error:=free_memory(font_adr[I]);
    END;


{EVENT}
{**************************************************************************
 *             START OF EVENT MANAGEMENT ROUTINE                          *
 *                                                                        *
 *             INPUT: None.                                               *
 *                                                                        *
 *             OUTOUT: None                                               *
 *                                                                        *
 *             CALLED BY: Main Program.                                   *
 *                                                                        *
 **************************************************************************}

PROCEDURE Event_Loop;
    VAR rx,ry,rw,rh,dummy:integer;
        msg:Message_Buffer;
    BEGIN
      REPEAT
        which:=Get_Event(E_Message|E_Timer|E_Button,1,1,1,0,
             false,0,0,0,0,false,0,0,0,0,msg,dummy,dummy,dummy,dummy,
             dummy,dummy);

        IF (which & E_message<>0) THEN CASE msg[0] of
             MN_Selected : BEGIN
                              IF msg[3]=Desk_title THEN about_ldgfont;
                              Menu_Normal(menu,msg[3]);
                           END;
             WM_Closed   :  BEGIN
                               Set_color(3,100,1000,100);
                               close_window(msg[3]);
                               delete_window(msg[3]);
                               Work_rect(front_window,x,y,w,h);
                               IF msg[3]=font_window THEN font_window:=0;
                            END;
             WM_Redraw   : BEGIN
                              begin_update;
                              hide_mouse;
                              First_rect(msg[3],rx,ry,rw,rh);
                              While (rw<>0) AND (rh<>0) DO
                                BEGIN
                                  IF Rect_intersect(msg[4],msg[5],msg[6],msg[7]
                                                    ,rx,ry,rw,rh) THEN
                                  BEGIN
                                     Set_clip(rx,ry,rw,rh);
                                     IF msg[3]=font_window THEN draw_fonts;
                                     work_rect(msg[3],x,y,w,h);
                                     Set_clip(x,y,w,h);
                                  END;
                                Next_rect(msg[3],rx,ry,rw,rh);
                                END;
                              end_update;
                              show_mouse;
                           END;

             END;  {CASE}
      UNTIL msg[4]=quit_item;
    END;


{**************************************************************************
 *                                                                        *
 *             MAKES THE MENU BAR                                         *
 *                                                                        *
 *             INPUT: None.                                               *
 *                                                                        *
 *             OUTPUT: None.                                              *
 *                                                                        *
 *             CALLED BY: Main Program.                                   *
 *                                                                        *
 **************************************************************************}

PROCEDURE make_menu;
    BEGIN
       menu:=new_menu(25,'  About LOAD FONT  ');
       prog_title:=add_mtitle(menu,           '  PROGRAM    ');
       line_item:=add_mitem(menu,prog_title,  '-------------');
       quit_item:=add_mitem(menu,prog_title,  '  QUIT       ');
       menu_disable(menu,line_item);
    END;


{**************************************************************************
 *                                                                        *
 *             CLOSES A VIRTUAL WORKSTATION                               *
 *                                                                        *
 *             INPUT: None.                                               *
 *                                                                        *
 *             OUTPUT: None.                                              *
 *                                                                        *
 *             CALLED BY: Main Program.                                   *
 *                                                                        *
 **************************************************************************}

PROCEDURE quit_window;
    BEGIN
       close_window(font_window);
       delete_window(font_window);
    END;



{*************************************************************************
 *                                                                       *
 *             MAIN PROGRAM ROUTINE                                      *
 *                                                                       *
 *              1.  Gets system resolution (getrez).                     *
 *              2.  Initilizes the mouse (init_mouse).                   *
 *              3.  Initilizes the fonts (init_fonts).                   *
 *              4.  Design the Menu Bar (make_menu).                     *
 *              5.  Draws the Menu Bar (draw_menu).                      *
 *              6.  Defines the GEM window (wind_font).                  *
 *              7.  Gets the VDI handle  (get_port).                     *
 *              8.  Cleans up the window (draw_fonts).                   *
 *              9.  Selects the fonts (select_fonts).                    *
 *             10.  Branches to Event Management routine (event_loop).   *
 *             11.  Erases the window (quit_window).                     *
 *             12.  Restores the old GEM fonts (restore_system).         *
 *             13.  Exits GEM (exit_gem).                                *
 *                                                                       *
 *************************************************************************}

  BEGIN
    IF Init_gem>=0 THEN
      BEGIN
        rewrite(output,'prn:');
        rez:=getrez;                      
        init_mouse;
        linea_parm:=init_fonts(font_adr[1],effects_buf,color_parm,mono_parm);
        fonts_loaded:=FALSE;
        make_menu;
        draw_menu(menu);
        wind_font;      
        vdi_handle:=get_port;
        draw_fonts;
        select_fonts;
        event_loop;               
        quit_window;                    
        rewrite(output,'CON:');
        restore_system(linea_parm,color_parm,mono_parm);
        restore_memory;
        exit_gem;
      END;
  END.



