{$M+,E+}

PROGRAM Load_gemfont_object_pas;

{**************************************************************************
 *                                                                        *
 *                         TACKLE BOX ST DEMO                             *
 *                                                                        *
 * This OBJECT file is included as part of the TACKLE BOX ST demo called  *
 * FNTDEMO.PRG.  You may freely use or change this demo in any way you    *
 * see fit.  If you make extensive changes to this demo, we would         *
 * appreciate you sending us a copy so that we may distribute it to other *
 * Personal Pascal users.  Thank you.                                    *
 *                                                                        *
 *                             Rusty Mullins                              *
 *                             compuserve: 70707,3045                     *
 *                             genie: R.E.MULLINS                         *                                              *
 *                                                                        *
 *                                SRM ENTERPRISES                         *
 *                                P.O. BOX 40                             *
 *                                USAFA, CO 80840                         *
 *                                (719) 472-6624                          *
 *                                                                        *
 *                                                                        *
 *                                                                        *
 *     FNTDEMO.PAS (version 1.00) is a demo to load GDOS compatible fonts *
 *     WITHOUT using GDOS.                                                *
 *                                                                        *
 *     The documentation that goes along with this demo is contained in   *
 *     Tutorial chapter and is called 'Using fonts without GDOS.'  This   *
 *     tutorial hopefully explains everything you need to know about      *
 *     loading, using and unloading fonts.                                *
 *                                                                        *
 *                                                                        *
 *    Compiling this Program:                                             *
 *                                                                        *
 *    There is nothing special about compiling this program.  All VDI     *
 *    and AES commands are there (nothing to INCLUDE).  Just compile and  *
 *    link for GEM.  NOTE: The U50 compiler at the top of the program is  *
 *    neccessary in order to make memory available to load the fonts!     *
 *                                                                        *
 *    Linking this program:                                               *
 *                                                                        *
 *     'LOADFNT.O' must be placed in the LINK OPTIONS dialog box.  Don't  *
 *     forget to specify its proper path (i.e. A:).                       *
 *                                                                        *
 **************************************************************************}


{**************************************************************************
 *                                                                        *
 *                   EXTERNAL DECLARATIONS                                *
 *                                                                        *
 **************************************************************************}

FUNCTION malloc(resrvd:long_integer):long_integer;  GEMDOS($48);

FUNCTION mfree(num_bytes:long_integer):integer; gemdos($49);

PROCEDURE SuperExec(addr:long_integer);  XBIOS(38);

FUNCTION getrez:integer; XBIOS(4);

FUNCTION Peek(Address:Long_Integer): BYTE; EXTERNAL;

FUNCTION Wpeek(Address:Long_Integer): Integer;	EXTERNAL;

FUNCTION Lpeek(Address:Long_Integer):Long_Integer; EXTERNAL;

PROCEDURE Poke(Address:Long_Integer; Value:BYTE); EXTERNAL;

PROCEDURE Wpoke(Address:Long_Integer; Value:Integer);	EXTERNAL;

PROCEDURE Lpoke(Address:Long_Integer; Value:Long_Integer); EXTERNAL;


{*************************************************************************
 *                                                                       *
 *            TEXT JUSTIFICATION ROUTINE                                 *
 *                                                                       *
 *            INPUT:                                                     *
 *             1.  vdi_handle : The VDI handle.                          *
 *             2.  x          : Text X position.                         *
 *             3.  y          : Text Y position.                         *
 *             4.  text_str   : Text string (a pascal string);           *
 *             5.  text_len   : Final length of text.                    *
 *             6.  word_str   : Word stretch flag.                       *
 *             7.  char_str   : Character stretch flag.                  *
 *                                                                       *
 *            OUTPUT: None.                                              *
 *                                                                       *
 *************************************************************************}

PROCEDURE text_justify(vdi_hand,x,y:integer; VAR text_str:string;
                       text_len,word_str,char_str:integer);
    TYPE
     Int_In_parms    = ARRAY [0..90]   OF Short_Integer;
     Int_Out_parms   = ARRAY [0..45]   OF Short_Integer;
     Ctrl_Parms      = ARRAY [ 0..11 ] OF Short_Integer ;
     Pts_In_Parms    = ARRAY [ 0..11 ] OF Short_Integer ;
     Pts_Out_Parms   = ARRAY [ 0..11 ] OF Short_Integer ;

    VAR 
        Control  : Ctrl_Parms;                            {AES and VDI vars}
        Int_In   : Int_In_Parms;
        Int_Out  : Int_Out_Parms;
        Pts_In   : Pts_In_Parms;
        Pts_Out  : Pts_Out_Parms;
        I : integer;

     PROCEDURE VDI_Call(cmd, sub_cmd : Short_Integer;
                        nints, npts  : Short_Integer;
                        VAR ctrl     : Ctrl_Parms;
                        VAR int_in   : Int_In_Parms;
                        VAR int_out  : Int_Out_Parms;
                        VAR pts_in   : Pts_In_Parms;
                        VAR pts_out  : Pts_Out_Parms;
                        translate    : boolean);
               EXTERNAL ;
    BEGIN
       pts_in[0]:=x;
       pts_in[1]:=y;
       pts_in[2]:=text_len;
       pts_in[3]:=0;

       int_in[0]:=word_str;
       int_in[1]:=char_str;
       FOR I:=1 TO length(text_str) DO int_in[I+1]:=ORD(text_str[I]);
       int_in[length(text_str)+2]:=ORD(chr(0));
       control[6]:=vdi_hand;
       VDI_Call(11,10,length(text_str)+2,2,Control,Int_In,Int_Out,Pts_In,Pts_Out,False);
    END;


{*************************************************************************
 *                                                                       *
 *            TEXT ALIGNMENT ROUTINE                                     *
 *                                                                       *
 *            INPUT:                                                     *
 *             1.  vdi_handle : The VDI handle.                          *
 *             2.  hor_align  : The horizontal alignment flag.           *
 *             3.  ver_align  : The vertical alignment flag.             *
 *             4.  set_hor    : The set horizontal alignment.            *
 *             5.  set_ver    : The set vertical alignment.              *
 *                                                                       *
 *            OUTPUT: None.                                              *
 *                                                                       *
 *************************************************************************}

PROCEDURE text_alignment(vdi_hand,hor_align,ver_align:integer;
                         VAR set_hor,set_ver:integer);
    TYPE
     Int_In_parms    = ARRAY [0..15]   OF Short_Integer;
     Int_Out_parms   = ARRAY [0..45]   OF Short_Integer;
     Ctrl_Parms      = ARRAY [ 0..11 ] OF Short_Integer ;
     Pts_In_Parms    = ARRAY [ 0..11 ] OF Short_Integer ;
     Pts_Out_Parms   = ARRAY [ 0..11 ] OF Short_Integer ;

    VAR 
        Control  : Ctrl_Parms;                            {AES and VDI vars}
        Int_In   : Int_In_Parms;
        Int_Out  : Int_Out_Parms;
        Pts_In   : Pts_In_Parms;
        Pts_Out  : Pts_Out_Parms;
    
     PROCEDURE VDI_Call(cmd, sub_cmd : Short_Integer;
                        nints, npts  : Short_Integer;
                        VAR ctrl     : Ctrl_Parms;
                        VAR int_in   : Int_In_Parms;
                        VAR int_out  : Int_Out_Parms;
                        VAR pts_in   : Pts_In_Parms;
                        VAR pts_out  : Pts_Out_Parms;
                        translate    : boolean);
               EXTERNAL ;
    BEGIN
       int_in[0]:=hor_align;
       int_in[1]:=ver_align;
       control[6]:=vdi_hand;
       VDI_Call(39,0,2,0,Control,Int_In,Int_Out,Pts_In,Pts_Out,False);
       set_hor:=int_out[0];
       set_ver:=int_out[1];
    END;


{*************************************************************************
 *                                                                       *
 *            SET THE CHARACTER ROTATION                                 *
 *                                                                       *
 *            INPUT:                                                     *
 *             1.  vdi_handle : The VDI handle.                          *
 *             2.  rot. angle : The angle of rotation.                   *
 *                                                                       *
 *            OUTPUT:                                                    *
 *             1.  text_rotation :  The rotation angle.                  *
 *                                                                       *
 *************************************************************************}

PROCEDURE text_rotation(vdi_hand,id_font:integer);
    TYPE
     Int_In_parms    = ARRAY [0..15]   OF Short_Integer;
     Int_Out_parms   = ARRAY [0..45]   OF Short_Integer;
     Ctrl_Parms      = ARRAY [ 0..11 ] OF Short_Integer ;
     Pts_In_Parms    = ARRAY [ 0..11 ] OF Short_Integer ;
     Pts_Out_Parms   = ARRAY [ 0..11 ] OF Short_Integer ;

    VAR 
        Control  : Ctrl_Parms;                            {AES and VDI vars}
        Int_In   : Int_In_Parms;
        Int_Out  : Int_Out_Parms;
        Pts_In   : Pts_In_Parms;
        Pts_Out  : Pts_Out_Parms;
    
     PROCEDURE VDI_Call(cmd, sub_cmd : Short_Integer;
                        nints, npts  : Short_Integer;
                        VAR ctrl     : Ctrl_Parms;
                        VAR int_in   : Int_In_Parms;
                        VAR int_out  : Int_Out_Parms;
                        VAR pts_in   : Pts_In_Parms;
                        VAR pts_out  : Pts_Out_Parms;
                        translate    : boolean);
               EXTERNAL ;
    BEGIN
       int_in[0]:=id_font;
       control[6]:=vdi_hand;
       VDI_Call(13,0,1,0,Control,Int_In,Int_Out,Pts_In,Pts_Out,False);
    END;


{*************************************************************************
 *                                                                       *
 *            GET THE NAME AND THE ID OF THE FONTS LOADED                *
 *                                                                       *
 *            INPUT:                                                     *
 *             1.  vdi_handle : The VDI handle                           *
 *             2.  ele_num    : The rank (order) of the font.            *
 *                                                                       *
 *            OUTPUT:                                                    *
 *             1.  vgt_name   :  The Font ID.                            *
 *             2.  face_name  :  The Font Name                           *
 *                                                                       *
 *************************************************************************}

FUNCTION get_fontid(vdi_hand,ele_num:integer; VAR face_name:string):integer;
    TYPE
     Int_In_parms    = ARRAY [0..15]   OF Short_Integer;
     Int_Out_parms   = ARRAY [0..45]   OF Short_Integer;
     Ctrl_Parms      = ARRAY [ 0..11 ] OF Short_Integer ;
     Pts_In_Parms    = ARRAY [ 0..11 ] OF Short_Integer ;
     Pts_Out_Parms   = ARRAY [ 0..11 ] OF Short_Integer ;

    VAR I:integer;
        Control  : Ctrl_Parms;                            {AES and VDI vars}
        Int_In   : Int_In_Parms;
        Int_Out  : Int_Out_Parms;
        Pts_In   : Pts_In_Parms;
        Pts_Out  : Pts_Out_Parms;
    
     PROCEDURE VDI_Call(cmd, sub_cmd : Short_Integer;
                        nints, npts  : Short_Integer;
                        VAR ctrl     : Ctrl_Parms;
                        VAR int_in   : Int_In_Parms;
                        VAR int_out  : Int_Out_Parms;
                        VAR pts_in   : Pts_In_Parms;
                        VAR pts_out  : Pts_Out_Parms;
                        translate    : boolean);
               EXTERNAL ;

    BEGIN
       face_name:='';
       int_in[0]:=ele_num;
       control[6]:=vdi_hand;
       VDI_Call(130,0,1,0,Control,Int_In,Int_Out,Pts_In,Pts_Out,False);
       FOR I:=1 to 32 DO 
         BEGIN
            IF int_out[I] = 0 THEN int_out[I]:=32;         
            face_name:=CONCAT(face_name,chr(int_out[I]&255));
         END;
       get_fontid:=int_out[0];                           {id num}
    END;


{*************************************************************************
 *                                                                       *
 *            SET THE CHARACTER SET (FONT)                               *
 *                                                                       *
 *            INPUT:                                                     *
 *             1.  vdi_handle : The VDI handle.                          *
 *             2.  font       : The font ID.                             *
 *                                                                       *
 *            OUTPUT:                                                    *
 *             1.  vgt_font   :  The ID of the font selected.            *
 *                                                                       *
 *************************************************************************}

FUNCTION set_font(vdi_hand,id_font:integer):integer;
    TYPE
     Int_In_parms    = ARRAY [0..15]   OF Short_Integer;
     Int_Out_parms   = ARRAY [0..45]   OF Short_Integer;
     Ctrl_Parms      = ARRAY [ 0..11 ] OF Short_Integer ;
     Pts_In_Parms    = ARRAY [ 0..11 ] OF Short_Integer ;
     Pts_Out_Parms   = ARRAY [ 0..11 ] OF Short_Integer ;

    VAR 
        Control  : Ctrl_Parms;                            {AES and VDI vars}
        Int_In   : Int_In_Parms;
        Int_Out  : Int_Out_Parms;
        Pts_In   : Pts_In_Parms;
        Pts_Out  : Pts_Out_Parms;
    
     PROCEDURE VDI_Call(cmd, sub_cmd : Short_Integer;
                        nints, npts  : Short_Integer;
                        VAR ctrl     : Ctrl_Parms;
                        VAR int_in   : Int_In_Parms;
                        VAR int_out  : Int_Out_Parms;
                        VAR pts_in   : Pts_In_Parms;
                        VAR pts_out  : Pts_Out_Parms;
                        translate    : boolean);
               EXTERNAL ;
    BEGIN
       int_in[0]:=id_font;
       control[6]:=vdi_hand;
       VDI_Call(21,0,1,0,Control,Int_In,Int_Out,Pts_In,Pts_Out,False);
       set_font:=int_out[0];
    END;


{**************************************************************************
 *                                                                        *
 *             Initilize Fonts                                            *
 *                                                                        *
 *              1. Sets pointer value for System Font.                    *
 *              2. Saves pointers for color and mono so they can be       *
 *                 restored later on (Restore_System).                    *
 *              3. Mallocs the effects Buffer.                            *
 *              4. Gets the Line A parameter block.                       *
 *                                                                        *
 *             INPUT: None.                                               *
 *                                                                        *
 *             OUTPUT: None                                               *
 *                                                                        *
 **************************************************************************}

FUNCTION Init_fonts(VAR sys_font,eff_buf,color_value,
                    mono_value:long_integer):long_integer;
    VAR rez,error_code:integer; 
        asm_area,line_a_parm,color_offset,mono_offset:long_integer;

    BEGIN
       rez:=getrez;
       eff_buf:=malloc(1000);
       asm_area:=malloc(200);
       lpoke(asm_area, $48F97FFF);      { Save Registers D0-D7 & A0-A6 }
       lpoke(asm_area+4,asm_area+28);   { MOVEM.L D0-D7/A0-A6, asm_area+22 }

       wpoke(asm_area+8 ,$A000);        {.dc.w $A000}
       lpoke(asm_area+10 ,$48F90001);   {movem.l D0,parm_adr} 
       lpoke(asm_area+14,asm_area+32);  {parm_adr = asm_area+32} 

       lpoke(asm_area+18,$4CF97FFF);    { Restore Registers D0-D7 & A0-A6 }
       lpoke(asm_area+22,asm_area+28);  { MOVEM.L asm_area+22,D0-D7/A0-A6 }

       wpoke(asm_area+26,$4E75);        { RTS }
       SuperExec(asm_area);             { Execute at this address}

       line_a_parm:=lpeek(asm_area+32);  {get linea Parm from asm_area+32}
       error_code:=mfree(asm_area);     {deallocate code}

       color_offset:=line_a_parm - $1C4;
       mono_offset:=line_a_parm - $1CC;
       mono_value:=lpeek(mono_offset);
       color_value:=lpeek(color_offset);
       IF rez = 2 THEN sys_font:=mono_value
       ELSE IF rez < 2 THEN sys_font:=color_value;
       init_fonts:=line_a_parm;
    END;


{**************************************************************************
 *                                                                        *
 *             Restore System:                                            *
 *              1. Restores pointer values for System Fonts.              *
 *              2. Dealloctes font memory.                                *
 *                                                                        *
 *             INPUT: None.                                               *
 *                                                                        *
 *             OUTPUT: None                                               *
 *                                                                        *
 **************************************************************************}

PROCEDURE Restore_System(line_a_parm,color_value,mono_value:long_integer);
    VAR I,error_code:integer;
        color_offset,mono_offset:long_integer;
    BEGIN
       color_offset:=line_a_parm - $1C4;
       mono_offset:=line_a_parm - $1CC;
       lpoke(mono_offset,mono_value);
       lpoke(color_offset,color_value);
       lpoke(color_value + $54, mono_value);
       lpoke(mono_value + $54 ,0);
    END;


{**************************************************************************
 *                                                                        *
 *             Free Memory:  Frees up font memory                         *
 *                                                                        *
 *             INPUT: Font_addr    : Font address.                        *
 *                                                                        *
 *             OUTPUT: Free_memory : Error_code.                          *
 *                                                                        *
 **************************************************************************}

FUNCTION Free_memory(font_addr:long_integer):long_integer;
    BEGIN
       free_memory:=mfree(font_addr);    
    END;


{**************************************************************************
 *                                                                        *
 *             Set Address                                                *
 *                                                                        *
 *              1. Sets pointer value for Character Offset.               *
 *              2. Sets pointer value for Font Data                       *
 *                                                                        *
 *             INPUT:                                                     *
 *              1. Font_Address:  Address of font loaded.                 *
 *                                                                        *
 *             OUTPUT: None                                               *
 *                                                                        *
 **************************************************************************}

PROCEDURE Set_Address(font_addr:long_integer);
    VAR hor_flag,form_width,form_hgt,form_offset,
        ade_hi,ade_lo,ade:integer;
        font_ptr:long_integer;

    BEGIN
       font_ptr:=font_addr;
       font_ptr:=font_ptr + 88;
       Lpoke(font_addr+72,font_ptr);

       ade_hi:=wpeek(font_addr+38);
       ade_lo:=wpeek(font_addr+36);
       ade:=ade_hi-ade_lo+2;
       ade:=ade+ade;
       font_ptr:=font_ptr + ade;
       lpoke(font_addr+76,font_ptr);
    
       lpoke(font_addr+68,0);
       hor_flag:=wpeek(font_addr+66);
       IF (hor_flag & 2) = 2 THEN
         BEGIN
            form_width:=wpeek(font_addr+80);
            form_hgt:=wpeek(font_addr+82);
            form_offset:=form_width * form_hgt;
            font_ptr:=font_ptr + form_offset;
            lpoke(font_addr + 68,font_ptr);
         END;
    END;


{**************************************************************************
 *                                                                        *
 *             Link Fonts                                                 *
 *                                                                        *
 *              1. Links all the fonts together.                          *
 *              2. Causing Font #1 to point to Font #2 which points       *
 *                 to Font #3.                                            *
 *                                                                        *
 *             INPUT:                                                     *
 *              1. First_Address :  Address of first font.                *
 *              2. Second_Address:  Address of second font.               *
 *              3. Third_Address :  Address of third font.                *
 *                                                                        *
 *             OUTPUT: None                                               *
 *                                                                        *
 **************************************************************************}

PROCEDURE Link_fonts(first_addr,second_addr:long_integer);
    BEGIN
       lpoke(first_addr+84,second_addr);
       lpoke(second_addr+84,0);
    END; 
 

{**************************************************************************
 *                                                                        *
 *             Register Fonts                                             *
 *                                                                        *
 *              1. Register font with GEM VDI.                            *
 *              2. After registering, font is selected using VST_FONT.    *
 *                                                                        *
 *                                                                        *
 *             INPUT:                                                     *
 *              1.  Handle     : VDI handle                               *
 *              2.  Font_List  : Address of the font that is at the head  *
 *                               of the font list.                        *
 *              3.  Effects_buf: Address of the special effects buffer    *
 *                                                                        *
 *             OUTPUT:                                                    *
 *              1. Number of additional fonts loaded                      *
 *                                                                        *
 **************************************************************************}

FUNCTION Reg_fonts(vdi_hand:integer; font_addr,eff_buf:long_integer)
                   :integer;
    TYPE
     Int_In_parms    = ARRAY [0..15]   OF Short_Integer;
     Int_Out_parms   = ARRAY [0..45]   OF Short_Integer;
     Ctrl_Parms      = ARRAY [ 0..11 ] OF Short_Integer ;
     Pts_In_Parms    = ARRAY [ 0..11 ] OF Short_Integer ;
     Pts_Out_Parms   = ARRAY [ 0..11 ] OF Short_Integer ;

    VAR 
        Control  : Ctrl_Parms;                            {AES and VDI vars}
        Int_In   : Int_In_Parms;
        Int_Out  : Int_Out_Parms;
        Pts_In   : Pts_In_Parms;
        Pts_Out  : Pts_Out_Parms;
    
     PROCEDURE VDI_Call(cmd, sub_cmd : Short_Integer;
                        nints, npts  : Short_Integer;
                        VAR ctrl     : Ctrl_Parms;
                        VAR int_in   : Int_In_Parms;
                        VAR int_out  : Int_Out_Parms;
                        VAR pts_in   : Pts_In_Parms;
                        VAR pts_out  : Pts_Out_Parms;
                        translate    : boolean);
               EXTERNAL ;

    BEGIN
       control[6]:=vdi_hand;
       control[7]:=Int(SHR(eff_buf,16) & $0000FFFF);
       control[8]:=Int(eff_buf & $0000FFFF);       
       control[9]:=500;
       control[10]:=Int(SHR(font_addr,16) & $0000FFFF);
       control[11]:=Int(font_addr & $0000FFFF);       
       int_in[0]:=0;
       vdi_call(119,0,1,0,control,int_in,int_out,pts_in,pts_out,false);
       reg_fonts:=int_out[0];
    END;
 

{**************************************************************************
 *                                                                        *
 *             Byte Swap                                                  *
 *                                                                        *
 *              1. Takes an INTEL formatted font and changes it into      *
 *                 a Motorola formatted font.                             *
 *                                                                        *
 *                                                                        *
 *             INPUT:                                                     *
 *              1.  Font Address :  Address of the font to change.        *
 *              2.  Size         :  Size (in bytes) of the font.          *
 *                                                                        *
 *             OUTPUT: NONE.                                              *
 *                                                                        *
 **************************************************************************}

PROCEDURE do_swap(addr:long_integer);
    VAR temp1:byte;
    BEGIN   
       temp1:=peek(addr);                   {holds second byte}
       poke(addr,peek(addr-1));             {move first byte to second} 
       poke(addr-1,temp1);                    {put second byte in first}
    END;


PROCEDURE byte_swap(font_addr,size:long_integer);
    VAR I:long_integer;
    BEGIN
       FOR I:=font_addr TO font_addr+3 DO       {first 4 bytes}
            IF odd(I) THEN do_swap(I);
                                                {skip font name}
       FOR I:=font_addr+37 TO font_addr+67 DO   {bytes 36 to 67}
            IF odd(I) THEN do_swap(I);
     
       FOR I:=font_addr+81 TO font_addr+size DO   {bytes 82 to finish}
            IF odd(I) THEN do_swap(I);
    END;  


{**************************************************************************
 *                                                                        *
 *             LOAD THE FONTS                                             *
 *                                                                        *
 *              1. Malloc enough memory.                                  *
 *              2. Load in the fonts.                                     *
 *              3. Call: Initilize Fonts.                                 *
 *              4. Call: Register Fonts.                                  *
 *                                                                        *
 *             INPUT: None.                                               *
 *                                                                        *
 *             OUTPUT:                                                    *
 *              1. Load_fonts :  Number of fonts loaded.                  *
 *                                                                        *
 **************************************************************************}

FUNCTION Load_font(vdi_hand:integer; VAR name:string; 
                   size:long_integer):long_integer;

    TYPE
        c_string =  packed array[0..255] OF CHAR;

    VAR file_hand,ret_code,I:integer;
        error_code,err_num:long_integer;
        cname:c_string;
        font_name: string;              {font name var}
        font_addr:long_integer;

    FUNCTION fopen(VAR fname:c_string; mode:integer):integer;  
             GEMDOS($3D);

    PROCEDURE fclose(handle:integer);  GEMDOS($3E);

    FUNCTION fread_addr(handle:integer; nbytes:long_integer;
                        addr:long_integer):long_integer;  GEMDOS($3F);

    PROCEDURE P_to_Cstr(Pstr:string; VAR Cstr:C_String); EXTERNAL;


    BEGIN
       font_addr:=malloc(size);

       IF font_addr>0 THEN
         BEGIN
            load_font:=font_addr;
            p_to_cstr(name,cname);   
            file_hand:=fopen(cname,0);      

            IF file_hand>=0 THEN
              BEGIN
                 error_code:=fread_addr(file_hand,size+2000,font_addr);

                 IF error_code>0 THEN
                   BEGIN
                      IF (peek(font_addr+67) & 4) <> 4 THEN
                          byte_swap(font_addr,error_code);
                      Set_address(font_addr);
                   END
                 ELSE IF error_code<0 THEN load_font:=error_code;
                 fclose(file_hand);        
              END
            ELSE IF file_hand < 0 THEN load_font:=file_hand;
         END
       ELSE IF font_addr < 0 THEN load_font:=font_addr;

    END;  


  BEGIN
  END.



